//
//  ViewController.m
//  CBCentralEx1
//
//  Created by 西田 五郎 on 2015/01/31.
//  Copyright (c) 2015年 isy. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize btnScan;
@synthesize btnConnect;
@synthesize btnClose;

@synthesize txtStatus;
@synthesize txtNotifyData;


- (void)viewDidLoad {
    [super viewDidLoad];
    
    //Centralの初期処理
    ///aQueue = dispatch_queue_create("jp.co.isy.centralmanager", DISPATCH_QUEUE_SERIAL);
    centralManager = [[CBCentralManager alloc] initWithDelegate:self queue:nil];
    
    [centralManager setDelegate:self];
    
    //画面の初期化
    btnScan.enabled = false;
    btnConnect.enabled = false;
    btnClose.enabled = false;
    
    txtStatus.text = @"";
    txtNotifyData.text = @"";
    
    //ペリフェラルUUIDの設定
    UUIDService = @"C52D11BC-C2EE-422D-955A-D834930CF567";
    UUIDCharacteristics = @"F13167B2-1FAE-4E7D-9200-B2DFA35510F8";
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)centralManagerDidUpdateState:(CBCentralManager *)central{
    
    //NSLog(@"State Updated");
    
    if(central.state == CBCentralManagerStatePoweredOn) {
        //scanボタンを有効にする
        btnScan.enabled = true;
        txtStatus.text = @"初期化完了";
    }
}

- (IBAction)OnBtnScan:(id)sender {
    
    btnScan.enabled = false;
    txtStatus.text = @"スキャン中";
    
    CBUUID *uuid = [CBUUID UUIDWithString:UUIDService];
    NSArray *services = [NSArray arrayWithObjects:uuid,nil];
    
    [centralManager scanForPeripheralsWithServices:services
        options:@{ CBCentralManagerScanOptionAllowDuplicatesKey : [NSNumber numberWithBool:YES]}];
}

- (void) centralManager:(CBCentralManager *)central didDiscoverPeripheral:(CBPeripheral *)aPeripheral advertisementData:(NSDictionary *)advertisementData RSSI:(NSNumber *)RSSI {
    
    //スキャンの終了
    [centralManager stopScan];
    
    //ペリフェラルを保持する（ここではペリフェラルは単独）
    targetPeripheral = aPeripheral;
    targetPeripheral.delegate = self;
    
    btnConnect.enabled = true;
    txtStatus.text = @"ペリフェラル検知";
}

- (IBAction)OnBtnConnect:(id)sender {
    btnConnect.enabled = false;
    txtStatus.text = @"サービススキャン中";
    
    [centralManager connectPeripheral:targetPeripheral options:nil];
}

- (void)centralManager:(CBCentralManager *)central didConnectPeripheral:(CBPeripheral *)peripheral
{
    //サービスを探す
    [peripheral discoverServices:nil];
}

- (void) peripheral:(CBPeripheral *)aPeripheral didDiscoverServices:(NSError *)error {
    
    //目的のキャラクタリスティスクを探す
    for (CBService *aService in aPeripheral.services){
        if ([aService.UUID isEqual:[CBUUID UUIDWithString:UUIDService]]) {
            [aPeripheral discoverCharacteristics:@[[CBUUID UUIDWithString:UUIDCharacteristics]]
                                      forService:aService];
        }
    }
}

- (void)peripheral:(CBPeripheral *)peripheral didDiscoverCharacteristicsForService:(CBService *)service
                    error:(NSError *)error
{
    // キャラクタリスティスクに対して Notify を受け取れるようにする
    for (CBService *service in peripheral.services) {
        for (CBCharacteristic *characteristic in service.characteristics) {
            [peripheral setNotifyValue:YES forCharacteristic:characteristic];
        }
    }
    
    txtStatus.text = @"Notify受付中";
    btnClose.enabled = true;
}

- (void)peripheral:(CBPeripheral *)peripheral
didUpdateValueForCharacteristic:(CBCharacteristic *)characteristic
             error:(NSError *)error
{
    txtStatus.text = @"Notify完了";
    
    //Notifyを受け取る
    NSString *stringFromData =
        [[NSString alloc] initWithData:characteristic.value encoding:NSUTF8StringEncoding];
    
    txtNotifyData.text = stringFromData;
}

- (IBAction)OnBtnClose:(id)sender {
    [centralManager cancelPeripheralConnection:targetPeripheral];
    btnClose.enabled = false;
}

@end






