//
//  ViewController.m
//  CBPeripheralEx1
//
//  Created by 西田 五郎 on 2015/02/02.
//  Copyright (c) 2015年 isy. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize btnAdvertising;
@synthesize btnNotify;

@synthesize txtNotify;
@synthesize txtStatus;

- (void)viewDidLoad {
    [super viewDidLoad];
    
    //ペリフェラルを初期化 ここでは、queueは使わない
    //ここでは初期化だけでサービスの追加はステート変更後に行う
    //このmanagerオブジェクトをペリフェラルとして以降使う
    manager = [[CBPeripheralManager alloc]initWithDelegate:self queue:nil];
    
    UUIDService = @"C52D11BC-C2EE-422D-955A-D834930CF567";
    UUIDCharacteristics = @"F13167B2-1FAE-4E7D-9200-B2DFA35510F8";
    
    btnNotify.enabled = false;
    btnAdvertising.enabled = false;
    
    txtNotify.delegate = self;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)peripheralManagerDidUpdateState:(CBPeripheralManager *)peripheral{

    switch (manager.state) {
        case CBPeripheralManagerStatePoweredOn:
        {
            CBUUID *sUDID = [CBUUID UUIDWithString:UUIDService];
            CBUUID *cUDID = [CBUUID UUIDWithString:UUIDCharacteristics];
       
            services = [[CBMutableService alloc]initWithType:sUDID primary:YES];
            characteristic = [[CBMutableCharacteristic alloc]initWithType:cUDID properties:CBCharacteristicPropertyNotify value:nil permissions:CBAttributePermissionsReadable];
        
            services.characteristics = @[characteristic];
            [peripheral addService:services];
        }
            
        default:
            break;
    }

}

- (void)peripheralManagerDidStartAdvertising:(CBPeripheralManager *)peripheral error:(NSError *)error{
    txtStatus.text = @"Advertis開始";
}

- (void)peripheralManager:(CBPeripheralManager *)peripheral didAddService:(CBService *)service error:(NSError *)error{
    
    txtStatus.text = @"Service追加完了";
    btnAdvertising.enabled = true;
}

- (void)peripheralManager:(CBPeripheralManager *)peripheral central:(CBCentral *)central didSubscribeToCharacteristic:(CBCharacteristic *)characteristic12{
    
    [manager stopAdvertising];
    
    NSString *stra = @"Init";
    NSData *dataa = [stra dataUsingEncoding:NSUTF8StringEncoding];
    
    bool isOK = [peripheral updateValue:dataa forCharacteristic:characteristic onSubscribedCentrals:nil];
    if(isOK){
        txtStatus.text = @"初回通知完了";
    }
    else{
        txtStatus.text = @"初回通知エラー";
    }
    
    btnNotify.enabled = true;
}

- (IBAction)onAdvertising:(id)sender {
    
    NSDictionary *advertisingData =
    @{CBAdvertisementDataLocalNameKey : @"ISYJP",
      CBAdvertisementDataServiceUUIDsKey : @[[CBUUID UUIDWithString:UUIDService]]};
    
    [manager startAdvertising:advertisingData];
    
    btnAdvertising.enabled = false;
}

- (IBAction)onNotify:(id)sender {
    NSData *dataa = [txtNotify.text dataUsingEncoding:NSUTF8StringEncoding];
    
    bool isOK = [manager updateValue:dataa forCharacteristic:characteristic onSubscribedCentrals:nil];
    if(isOK){
        txtStatus.text = @"通知処理完了";
    }
    else{
        txtStatus.text = @"通知処理エラー";
    }
}

- (void)peripheralManagerIsReadyToUpdateSubscribers:(CBPeripheralManager *)peripheral
{
    //送信が再度可能になった場合に呼ばれる
}

- (BOOL)textFieldShouldReturn:(UITextField *)sender {
    
    [sender resignFirstResponder];
    
    return true;
}

@end




